/*
 * A bunch of no-op functions. All this queue does is count the
 * number of objects in it, but it doesn't actually store them.
 *
 * (c)2008-2009, Cris Luengo, Centre for Image Analysis, Uppsala, Sweden.
 * GNU GPL v.3.0 -- see gpl-3.0.txt
 *
 */

#include <stdlib.h>
#include "pqt.h"

struct PQT__tmp__priorityqueue {
   int nelements;           /* number of elements on the queue */
};


PQT_error PQT_New
(
   PQT_priorityqueue *queue,
   int blocksize
)
{
   PQT_priorityqueue tmpqueue = 0;
   tmpqueue = (PQT_priorityqueue)malloc (sizeof (PQT__priorityqueue));
   if (!tmpqueue) return PQT_PROBLEM;
   tmpqueue->nelements = 0;
   *queue = tmpqueue;
   tmpqueue = 0;
   return PQT_OK;
}


void PQT_Free
(
   PQT_priorityqueue queue
)
{
   if (queue) {
      free (queue);
   }
   return;
}


PQT_error PQT_Push
(
   PQT_priorityqueue queue,
   void* pointer,
   float value
)
{
   queue->nelements++;
   return PQT_OK;
}


PQT_error PQT_Pop
(
   PQT_priorityqueue queue,
   void* *pointer,
   float *value
)
{
   if (queue->nelements<=0) {
      return PQT_PROBLEM;
   }
   queue->nelements--;
   if (pointer) {
      *pointer = 0;
   }
   if (value) {
      *value = 0;
   }
   return PQT_OK;
}


PQT_boolean PQT_IsEmpty
(
   PQT_priorityqueue queue
)
{
   if (queue->nelements<=0) {
      return PQT_TRUE;
   }
   else {
      return PQT_FALSE;
   }
}


int PQT_NElements
(
   PQT_priorityqueue heap
)
{
   return heap->nelements;
}


void PQT_Print ( PQT_priorityqueue queue ) {}
