% PLOT_SPEED_DEBALANCE   Generates the plot that compares different speed runs.

% (c)2008-2009, Cris Luengo, Centre for Image Analysis, Uppsala, Sweden.
% GNU GPL v.3.0 -- see gpl-3.0.txt

% What part of the results to plot
max_y = 3.5;

indx = [3,4,5,7,9,12];

% --- End of config ---

datacol = 3;

plotlabels
labels = labels(indx,:);
col = labels(:,1);
N = length(col);

figure, set(gcf,'position',figpos)
box on, hold on
set(gca,'position',[0.11,0.11,0.85,0.86])
set(gca,'fontsize',fontsize,'linewidth',1)
set(gca,'xscale','log','xlim',[5e2,max(data0(:,1))],'xtick',10.^(0:8),'ylim',[0,max_y])

results_speed1
data = data(indx);

base = mean(data0(:,datacol));
for ii=1:N
   x = data{ii}(:,1);
   y = (data{ii}(:,datacol)-base) * 1e6/Niter;
   h = plot(x,y,col{ii},'linewidth',1);
   darkencolor(h)
end

results_speed2
data = data(indx);

base = mean(data0(:,datacol));
for ii=1:N
   x = data{ii}(:,1);
   y = (data{ii}(:,datacol)-base) * 1e6/Niter;
   h = plot(x,y,[col{ii}(1:2),'--'],'linewidth',1); % convert it into dashed line
   darkencolor(h)
end

xlabel('Number of elements on the stack')
ylabel('Time it takes to do one hold operation (\mus)')
legend(labels(:,2),'location','northwest');
% title('Dashed lines show what happens when there is a larger push towards unbalancing the trees.')

print -deps2c -r300 -loose speed_debalance.eps
