/*
 * Some constants
 *
 * (c)2008-2009, Cris Luengo, Centre for Image Analysis, Uppsala, Sweden.
 * GNU GPL v.3.0 -- see gpl-3.0.txt
 *
 */


typedef enum {
   PQT_FALSE = 0,
   PQT_TRUE = 1
} PQT_boolean;

typedef enum {
   PQT_OK = 0,
   PQT_PROBLEM = 1
} PQT_error;


/* The data to be put in the queue */

typedef struct {
   void* pointer;      /* pointer into image */
   float value;        /* pixel value - used for sorting */
} PQT_pixel;


/* The queue */

typedef struct PQT__tmp__priorityqueue PQT__priorityqueue, *PQT_priorityqueue;
   /* contents of struct is different for each queue implementation */
PQT_error   PQT_New       (PQT_priorityqueue*, int);
   /* allocate and initialize the queue */
void        PQT_Free      (PQT_priorityqueue);
   /* free all space used by the queue */
PQT_error   PQT_Push      (PQT_priorityqueue, void*, float);
   /* push an elemet onto the queue */
PQT_error   PQT_Pop       (PQT_priorityqueue, void**, float*);
   /* pop the element with lowest value (highest priority) from the queue */
PQT_boolean PQT_IsEmpty   (PQT_priorityqueue);
   /* return PQT_TRUE if the queue is empty */
int         PQT_NElements (PQT_priorityqueue);
   /* return the number of elements on the queue */
void PQT_Print (PQT_priorityqueue);
   /* print a status of the queue, for debugging only */
